<?php
header('Pragma: no-cache');
header('Expires: 0');
header('Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT');
header('Cache-Control: no-cache, must-revalidate');

include 'inc/main.inc.php';
include 'ua/funcs.inc.php';

$error = false;
$error_msg = '';
$count = 0;

$user = '';
$pwd = '';
$key = '';
$host = '';
$ip = '';
$mx = '';
if (!empty($_GET)) {
 @$user = non_slashes_gpc($_GET['user']);
 @$pwd = non_slashes_gpc($_GET['pwd']);
 @$key = non_slashes_gpc($_GET['key']);
 @$host = non_slashes_gpc($_GET['host']);
 @$ip = non_slashes_gpc($_GET['ip']);
 @$mx = trim(non_slashes_gpc($_GET['mx']));
} elseif (!empty($HTTP_GET_VARS)) {
 @$user = non_slashes_gpc($HTTP_GET_VARS['user']);
 @$pwd = non_slashes_gpc($HTTP_GET_VARS['pwd']);
 @$key = non_slashes_gpc($HTTP_GET_VARS['key']);
 @$host = non_slashes_gpc($HTTP_GET_VARS['host']);
 @$ip = non_slashes_gpc($HTTP_GET_VARS['ip']);
 @$mx = trim(non_slashes_gpc($HTTP_GET_VARS['mx']));
}
$user = strtolower(trim($user));
$pwd = trim($pwd);
$key = trim($key);
$host = strtolower(trim($host));
$ip = trim($ip);

if ($key == '') {
if ($user == '') {
 $error = true;
 $error_msg .= "Bad username\n";
}
if ($pwd == '') {
 $error = true;
 $error_msg .= "Bad password\n";
}
}
if ($host == '') {
 $error = true;
 $error_msg .= "Bad host\n";
}

if (!$CBD = mysql_connect($mysql_host,$mysql_user,$mysql_pass)) {
 $clcnx = false;
 $return = false;
 $error = true;
 $error_msg[0] = 'Could not connect to mysql server';
} else {
 $clcnx = true;
 if (!mysql_select_db($mysql_db)) {
  $return = false;
  $error = true;
  $error_msg[0] = 'Could not select database \''.$mysql_db.'\'';
 }
}

if (!$error) {
 $valid_user = false;
 if (mykey_exists($key)) {
  $valid_user = true;
  $id_user = mykey_give($key);
 } else {
  if (!user_findid($user,false)) {
   $error = true;
   $error_msg = "No such user\n";
  } else {
  $id_user = user_findid($user);
  $infos = user_infos($id_user);
  if ($infos['password'] != $pwd) {
   $error = true;
   $error_msg = "Invalid password\n";
  } else {
   $valid_user = true;
  }
  }
 }
 if ($valid_user) {
  while (substr($host,-1,1) == ',') { $host = trim(substr($host,0,strrpos($host,','))); }
  if ($host == 'all') {
   $host = '';
   $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_user`=".addslashes($id_user)." AND `mode`<>3;"),$CBD);
   if (mysql_numrows($RS_query) != 0) {
    while ($RS = mysql_fetch_array($RS_query)) {
     array_walk($RS,'non_slashes_mysql');
     $sub = $RS['sub'];
     $id_domain = $RS['id_domain'];
     $infos = domain_infos($id_domain);
     $domain = $infos['domain'];
     $host .= $sub.'.'.$domain.',';
    }
    $host = substr($host,0,-1);
   } else {
    $host = '';
   }
  }
  $host_array = explode(',',$host);
  $host_array = array_unique($host_array);
  for ($i=0 ; $i < count($host_array) ; $i++) {
   $myhost = trim($host_array[$i]);
   $sub = substr($myhost,0,strpos($myhost,'.'));
   $domain = substr($myhost,strpos($myhost,'.')+1);
   $myhost = substr($myhost,strpos($myhost,'.')+1);
   if (strpos($host,'.') === false) {
   } else {
   while (!domain_findid($domain,false)) {
    if ($domain == '') { break; }
    $sub = substr($domain,0,strpos($domain,'.'));
    if (strpos($domain,'.') === false) {
     $domain = '';
    } else {
     $domain = substr($domain,strpos($domain,'.')+1);
    }
   }
   if (domain_findid($domain,false)) {
    $id_domain = domain_findid($domain);
    $vhost_exists = false;
    $RS_query = mysql_query(("SELECT * FROM `vhosts` WHERE `id_domain`=".addslashes($id_domain)." AND `sub`='".addslashes($sub)."' AND `mode`<>3;"),$CBD);
    if (mysql_numrows($RS_query) != 0) {
     $vhost = mysql_fetch_array($RS_query);
     array_walk($vhost,'non_slashes_mysql');
     if (!validate_ip($ip)) {
      if (validate_ip(gethostbyname($ip))) {
      if ($vhost['mode'] == 1) { $ip = gethostbyname($ip); }
      } else {
      $ip = getMyIP();
      }
     }
     if ($vhost['mode'] == 1) {
      if ($mx == 3) { // Only Disable MX
       $mxv = false; $mxip = '';
       $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $vhost['addr'], $vhost['url'], $mxv, $mxip, $vhost['wildcard'], $vhost['cloaked']);
      } elseif ($mx == 2) { // Only Enable/Update MX
       $mxv = true; $mxip = $ip;
       $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $vhost['addr'], $vhost['url'], $mxv, $mxip, $vhost['wildcard'], $vhost['cloaked']);
      } elseif ($mx == 1) { // Update IP + Enable/Update MX
       $mxv = true; $mxip = $ip;
       $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $ip, $vhost['url'], $mxv, $mxip, $vhost['wildcard'], $vhost['cloaked']);
      } elseif ($mx != '' && isset($mx)) { // Update IP + Disable MX
       $mxv = false; $mxip = '';
       $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $ip, $vhost['url'], $mxv, $mxip, $vhost['wildcard'], $vhost['cloaked']);
      } else { // Only Update IP
       $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $ip, $vhost['url'], $vhost['mx'], $vhost['mxip'], $vhost['wildcard'], $vhost['cloaked']);
      }
     } elseif ($vhost['mode'] == 2) {
      $mxv = false; $mxip = ''; $wild = false;
      $result = vhost_modif($vhost['id_vhost'], $vhost['mode'], $ip, $vhost['url'], $mxv, $mxip, $wild, $vhost['cloaked']);
     }
     if ($result) { $count++; }
    }
   }
   }
  }
 }
}

if ($count > 0) {
 $return = true;
} else {
 $return = false;
}

if ($clcnx)
mysql_close($CBD);

if ($error) {
 $return = false;
 $error_msg = substr($error_msg,0,-1);
 $error_msg = explode("\n",$error_msg);
}

if ($return) {
 if ($count > 1) {
 $msg = 'Updated '.$count.' hostnames.';
 } else {
 $msg = 'Updated '.$count.' hostname.';
 }
 $error_list = '';
} else {
 if ($error_msg == '')  
  $error_msg[0] = 'No valid hostname';
 $msg = 'Error Occurred While Processing Request :';
 $error_list = "<blockquote>";
 for ($i=0 ; $i < count($error_msg) ; $i++) {
 if ($i > 0) { $error_list .= '<br>'; }
 $error_list .= "<font face=\"Verdana\" size=\"2\">- ".$error_msg[$i]."</font>";
 }
 $error_list .= "</blockquote>\n";
}

include 'inc/header.tpl.php';
?>
<p><font face="Verdana" size="2"><?php echo $msg; ?></font></p>
<?php echo $error_list; ?>
<?php include 'inc/footer.tpl.php'; ?>
