#
# Structure de la table `domains`
#

CREATE TABLE `domains` (
  `id_domain` int(4) unsigned zerofill NOT NULL auto_increment,
  `domain` varchar(255) NOT NULL default '',
  `exclude` text NOT NULL,
  `dnsip` varchar(255) NOT NULL default '',
  `key` text NOT NULL,
  `enable_a` tinyint(1) NOT NULL default '0',
  `enable_ns` tinyint(1) NOT NULL default '0',
  `enable_url` tinyint(1) NOT NULL default '0',
  `max` int(11) NOT NULL default '-1',
  PRIMARY KEY  (`id_domain`),
  UNIQUE KEY `domain` (`domain`)
) TYPE=MyISAM;

#
# Structure de la table `users`
#

CREATE TABLE `users` (
  `id_user` int(8) unsigned zerofill NOT NULL auto_increment,
  `regdate` int(10) NOT NULL default '0',
  `username` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `firstname` varchar(255) NOT NULL default '',
  `lastname` varchar(255) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `key` text NOT NULL,
  `max` int(11) NOT NULL default '-2',
  PRIMARY KEY  (`id_user`),
  UNIQUE KEY `username` (`username`)
) TYPE=MyISAM;

#
# Structure de la table `vhosts`
#

CREATE TABLE `vhosts` (
  `id_vhost` int(8) unsigned zerofill NOT NULL auto_increment,
  `id_user` int(8) unsigned zerofill NOT NULL default '00000000',
  `id_domain` int(4) unsigned zerofill NOT NULL default '0000',
  `regdate` int(10) NOT NULL default '0',
  `moddate` int(10) NOT NULL default '0',
  `sub` text NOT NULL,
  `mode` tinyint(1) NOT NULL default '0',
  `addr` text NOT NULL,
  `url` text NOT NULL,
  `mx` tinyint(1) NOT NULL default '0',
  `mxip` varchar(255) NOT NULL default '',
  `wildcard` tinyint(1) NOT NULL default '0',
  `cloaked` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_vhost`)
) TYPE=MyISAM;
